from machine import Pin,I2C
import ssd1306
import time
import random
from random import randint
from time import sleep
i2c=I2C(scl=Pin(5),sda=Pin(4))
oled=ssd1306.SSD1306_I2C(128,64,i2c)
start = machine.Pin(12, machine.Pin.IN, machine.Pin.PULL_UP)
gracz1 = machine.Pin(13, machine.Pin.IN, machine.Pin.PULL_UP)
gracz2 = machine.Pin(14, machine.Pin.IN, machine.Pin.PULL_UP)
def plytki1(b):                              # FUNKCJE PŁYTEK DO MENU
        oled.vline(0,1+b,15,1)
        oled.vline(123,48-b,15,1)
def plytki2(b):
        oled.vline(0,48-b,15,1)
        oled.vline(123,1+b,15,1)
def ply1(b):                                # FUNKCJE PŁYTEK DO GRY
    oled.vline(0,1+b,15,1)
def ply2(b):
    oled.vline(123,1+b,15,1)   
def game():                                 # MENU NAPIS
    od=20
    od1=20
    oled.fill(0)
    oled.hline(od1,3,10,1) #literka S
    oled.vline(od1,3,5,1)
    oled.hline(od1,8,10,1)
    oled.vline(od1+10,8,5,1)
    oled.hline(od1,13,10,1)
    oled.hline(od1+od,3,10,1) #literka T
    oled.vline(od1+5+od,3,10,1)
    oled.hline(od1+2*od+3,9,5,1) #literka A
    for i in range(6):
        oled.pixel(od1+2*od+5+i,3+2*i,1)
        oled.pixel(od1+2*od+5-i,3+2*i,1)
    oled.hline(od1+3*od,3,10,1) #literka R
    oled.vline(od1+3*od,3,10,1)
    oled.vline(od1+10+od*3,3,5,1)
    oled.hline(od1+3*od,8,10,1)
    oled.pixel(od1+3*od+1,9,1)
    oled.pixel(od1+3*od+5,10,1)
    oled.pixel(od1+3*od+9,12,1)
    oled.pixel(od1+3*od+7,11,1)
    oled.pixel(od1+3*od+3,10,1)
    for i in range(5):
        oled.pixel(od1+3*od+2*i,8+i,1)
    oled.hline(od1+4*od,3,10,1) #literka T
    oled.vline(od1+5+4*od,3,10,1)
    oled.hline(od1+10,18,10,1) #literka G
    oled.vline(od1+10,18,10,1)
    oled.hline(od1+15,23,5,1)
    oled.hline(od1+10,28,10,1)
    oled.vline(od1+od,23,5,1)
    oled.hline(od1+od+10+3,24,5,1) #literka A
    for i in range(6):
        oled.pixel(od1+od+15+i,18+2*i,1)
        oled.pixel(od1+od+15-i,18+2*i,1)
    oled.vline(od1+2*od+10,18,10,1) #literka M
    oled.vline(od1+3*od,18,10,1)
    for i in range(6):
        oled.pixel(od1+2*od+10+i,18+i,1)
        oled.pixel(od1+3*od-i,18+i,1)
    oled.hline(od1+3*od+10,18,10,1) #literka E
    oled.vline(od1+3*od+10,18,10,1)
    oled.hline(od1+3*od+10,23,10,1)
    oled.hline(od1+3*od+10,28,10,1)
def plansza():                            # PLANSZA DO GRY
    oled.hline(0,0,124,1)
    oled.hline(0,63,124,1)
def starter(a,b):                         # ODLICZANIE DO STARTU
    a=str(b)
    oled.fill(0)
    plansza()
    plytki1(24)
    oled.text(a,60,30,1)
    oled.show()
    sleep(1)
def fight():                              # NAPIS STARTOWY
    oled.fill(0)
    plansza()
    plytki1(24)
    oled.text('FIGHT',45,30,1)
    oled.show()
    sleep(1)
def ball(x,y):                            # PIŁKA WYGLĄD
    oled.rect(x,y,5,5,1)
def wynik(b,d):
    a=str(b)
    c=str(d)
    oled.fill(0)
    plansza()
    oled.vline(0,0,63,1)
    oled.vline(123,0,63,1)
    oled.text(a,50,30,1)
    oled.text(":",60,30,1)
    oled.text(c,70,30,1)
    oled.show()
    sleep(1.5)
def over():
    od=20
    od1=20
    for i in range(10):
        oled.fill(0)
        plansza()
        oled.vline(0,0,63,1)
        oled.vline(123,0,63,1)
        if (i % 2 == 0):
            oled.hline(od1+10,18,10,1) #literka G
            oled.vline(od1+10,18,10,1)
            oled.hline(od1+15,23,5,1)
            oled.hline(od1+10,28,10,1)
            oled.vline(od1+od,23,5,1)
            oled.hline(od1+od+10+3,24,5,1) #literka A
            for i in range(6):
                oled.pixel(od1+od+15+i,18+2*i,1)
                oled.pixel(od1+od+15-i,18+2*i,1)
            oled.vline(od1+2*od+10,18,10,1) #literka M
            oled.vline(od1+3*od,18,10,1)
            for i in range(6):
                oled.pixel(od1+2*od+10+i,18+i,1)
                oled.pixel(od1+3*od-i,18+i,1)
            oled.hline(od1+3*od+10,18,10,1) #literka E
            oled.vline(od1+3*od+10,18,10,1)
            oled.hline(od1+3*od+10,23,10,1)
            oled.hline(od1+3*od+10,28,10,1)
            oled.hline(od1+10,33,10,1) # literka O
            oled.hline(od1+10,43,10,1)
            oled.vline(od1+10,33,10,1)
            oled.vline(od1+od,33,10,1)
            for i in range(6):         # literka V
                oled.pixel(od1+od+15+i,43-2*i,1)
                oled.pixel(od1+od+15-i,43-2*i,1)
            oled.hline(od1+2*od+10,33,10,1) #literka E
            oled.vline(od1+2*od+10,33,10,1)
            oled.hline(od1+2*od+10,38,10,1)
            oled.hline(od1+2*od+10,43,10,1)
            oled.hline(od1+3*od+10,33,10,1) #literka R
            oled.vline(od1+3*od+10,33,10,1)
            oled.vline(od1+4*od,33,5,1)
            oled.hline(od1+3*od+10,38,10,1)
            oled.pixel(od1+3*od+11,39,1)
            oled.pixel(od1+3*od+15,40,1)
            oled.pixel(od1+3*od+19,42,1)
            oled.pixel(od1+3*od+17,41,1)
            oled.pixel(od1+3*od+13,40,1)
            for i in range(5):
                oled.pixel(od1+3*od+10+2*i,38+i,1)
        oled.show()   
        sleep(0.3)
def match():
    m=1
    wy1=0
    wy2=0
    while m==1:
        p1=12
        p2=12
        x=60
        y=30
        x0=0
        y0=0
        x1=0
        y1=0
        ba=0
        z=1
        while z==1:
            oled.fill(0)                            # INICJALIZACJA BOISKA
            plansza()
            if (x0!=0 or y0!=0):                             # TOR LOTU PIŁKI
                x1=x1+x0
                y1=y1+y0
            ball(x+x1,y+y1)
            X=x+x1
            Y=y+y1
            if (x0==0 and y0==0 and ba==0):                # ZACZĘCIE OD ŚRODKA 
                x0=randint(-5,5)
                y0=randint(-5,5)
                while x0==0:
                    x0=randint(-5,5)
                ba=1  
            if gracz1.value()==1:                   # STEROWANIE PŁYTKAMI
                ply1(2*p1)
                p1+=1
                if p1>=31:
                    p1=-8
            if gracz2.value()==1:
                ply2(2*p2)
                p2+=1
                if p2>=31:
                    p2=-8        
            if gracz1.value()==0:
                ply1(2*p1)
                p1-=1
                if p1<=-8:
                    p1=31
            if gracz2.value()==0:
                ply2(2*p2)
                p2-=1
                if p2<=-8:
                    p2=31
            if (Y>58 or Y<1) :                             # ODBICIE OD ŚCIANY
                y0=-y0
            if (Y>=6+2*p1 and Y<=11+2*p1 and X<=0):           # OBRONA POCZĄTEK
                x0=-x0
            if (Y>=6+2*p2 and Y<=11+2*p2 and X>=118):
                x0=-x0
            if (Y>=1+2*p1 and Y<6+2*p1 and X<=0):
                x0=-x0+1
            if (Y>11+2*p1 and Y<=16+2*p1 and X<=0):
                x0=-x0+1
            if (Y>11+2*p2 and Y<=16+2*p2 and X>=118):
                x0=-x0-1
            if (Y>=1+2*p2 and Y<6+2*p2 and X>=118):
                x0=-x0-1                             # OBRONA KONIEC
            oled.show()       
            sleep(0.03)
            if (X<-5):                                     # GOL POCZĄTEK
                z=0
                wy2=wy2+1
                wynik(wy1,wy2)
                if (wy1!=5 and wy2!=5):
                    for i in range(3):
                           starter(i,3-i)
                    fight()       
            if (X>123):
                z=0
                wy1=wy1+1
                wynik(wy1,wy2)
                if (wy1!=5 and wy2!=5):
                    for i in range(3):
                           starter(i,3-i)
                    fight()       
            if (wy1==5 or wy2==5):
                z=0
                m=0
x=0
a=0
while True:
    while x<26:
        if start.value()==1:                            #MENU GŁÓWNE
            if a==0:
                if x>=23:
                    x=0
                    a=1
                else:
                    game()
                    plytki1(2*x)
                    oled.show()
                    sleep(0.03)
                    oled.fill(0)
                    x+=1
            if a==1:
                if x>=23:
                    x=0
                    a=0
                else:
                    game()
                    plytki2(2*x)
                    oled.show()
                    sleep(0.03)
                    oled.fill(0)
                    x+=1   
        if start.value()==0:                              # ROZGRYWKA
            for i in range(10):
                   starter(i,10-i)
            fight()
            match()
            over()